POJ 2289 Jamie's Contact Groups / UVA 1345 Jamie's Contact Groups / ZOJ 2399 Jamie's Contact Groups / HDU 1699 Jamie's Contact Groups / SCU 1996 Jamie's Contact Groups (二分,二分图匹配)

POJ 2289 Jamie's Contact Groups / UVA 1345 Jamie's Contact Groups / ZOJ 2399 Jamie's Contact Groups / HDU 1699 Jamie's Contact Groups / SCU 1996 Jamie's Contact Groups (二分,二分图匹配)

Description

Jamie is a very popular girl and has quite a lot of friends, so she always keeps a very long contact list in her cell phone. The contact list has become so long that it often takes a long time for her to browse through the whole list to find a friend's number. As Jamie's best friend and a programming genius, you suggest that she group the contact list and minimize the size of the largest group, so that it will be easier for her to search for a friend's number among the groups. Jamie takes your advice and gives you her entire contact list containing her friends' names, the number of groups she wishes to have and what groups every friend could belong to. Your task is to write a program that takes the list and organizes it into groups such that each friend appears in only one of those groups and the size of the largest group is minimized.

Input

There will be at most 20 test cases. Ease case starts with a line containing two integers N and M. where N is the length of the contact list and M is the number of groups. N lines then follow. Each line contains a friend's name and the groups the friend could belong to. You can assume N is no more than 1000 and M is no more than 500. The names will contain alphabet letters only and will be no longer than 15 characters. No two friends have the same name. The group label is an integer between 0 and M - 1. After the last test case, there is a single line `0 0' that terminates the input.

Output

For each test case, output a line containing a single integer, the size of the largest contact group.

Sample Input

3 2
John 0 1
Rose 1
Mary 1
5 4
ACM 1 2 3
ICPC 0 1
Asian 0 2 3
Regional 1 2
ShangHai 0 2
0 0

Sample Output

2
2

Http

POJ:https://vjudge.net/problem/POJ-2289
UVA:https://vjudge.net/problem/UVA-1345
ZOJ:https://vjudge.net/problem/ZOJ-2399
HDU:https://vjudge.net/problem/HDU-1669
SCU:https://vjudge.net/problem/SCU-1996

Source

二分法,二分图最大匹配

题目大意

现在有n个人,有m个小组,每个人都有若干个小组供选择进入,但一个人最多只能进一个小组。现在求最大小组人数的最小值。

解决思路

我在前面的文章中也说过,这种求最大小组人数最小值的方法就是二分答案。

每次二分最大小组人数,然后判断能否找到一种方案使得所有小组的人数都不超过这个值。

至于怎么判断,那我们就是用二分图最大匹配中的匈牙利算法。

关于匈牙利算法的基本内容,这里不再多说,可以参考我的这三篇文章。
http://www.cnblogs.com/SYCstudio/p/7138206.html
http://www.cnblogs.com/SYCstudio/p/7138221.html
http://www.cnblogs.com/SYCstudio/p/7138230.html

最后要注意的是,因为这里的一个组内可以有多个人,所以组的Match不是唯一的,那么我们设Match[i][j],表示i组第当前匹配的第j个人,设Num[i]表示第i组的人数。那么匈牙利算法也要有一些变动,具体请看代码。

代码

#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<algorithm>
#include<vector>
#include<string>
#include<set>
using namespace std;

const int maxN=2001;
const int maxM=1001;
const int inf=2147483647;

int n,m;
int MaxCnt;
vector<int> E[maxN];
int Match[maxN][maxN];
int Num[maxN];
bool vis[maxN];

bool check(int mid);
bool Hungary(int u);

int main()
{
	while (cin>>n>>m)
	{
		if ((n==0)&&(m==0))
			break;
		for (int i=1;i<=n;i++)//init
			E[i].clear();

		string str;
		int x;
		for (int i=1;i<=n;i++)
        {
            cin>>str;
            char ch=getchar();
            while (ch!='\n')//读入,一定要注意啊
            {
                cin>>x;
                E[i].push_back(x+1);
                ch=getchar();
            }
        }
		/*for (int i=1;i<=n;i++)
		{
			for (int j=0;j<E[i].size();j++)
				cout<<E[i][j]<<' ';
			cout<<endl;
		}
		cout<<endl;*/
		int l=0,r=n;
		int Ans=0;
		do//二分答案
		{
			//cout<<l<<' '<<r<<endl;
			int mid=(l+r)/2;
			if (check(mid))
			{
				r=mid;
				Ans=mid;
			}
			else
			{
				l=mid+1;
			}
		}
		while (l<r);
        cout<<l<<endl;//最后输出
	}
	return 0;
}

bool check(int mid)
{
	MaxCnt=mid;
	memset(Num,0,sizeof(Num));
	memset(Match,-1,sizeof(Match));
	for (int i=1;i<=n;i++)
	{
		memset(vis,0,sizeof(vis));
		if (!Hungary(i))//因为必须所有人都匹配,所以若有一个人不能则匹配失败
			return 0;
	}
	return 1;
}

bool Hungary(int u)
{
	for (int i=0;i<E[u].size();i++)
	{
		int v=E[u][i];
		if (vis[v]==0)
		{
			vis[v]=1;
			if (Num[v]<MaxCnt)//首先判断能否直接加入
			{
				Num[v]++;
				Match[v][Num[v]]=u;
				return 1;
			}
			for (int j=1;j<=Num[v];j++)//否则依次将v之前匹配的人进行“让”操作,看能否让出来给u
			{
				if (Hungary(Match[v][j]))
				{
					Match[v][j]=u;
					return 1;
				}
			}
		}
	}
	return 0;
}
posted @ 2017-07-08 22:33  SYCstudio  阅读(361)  评论(0编辑  收藏  举报